// FOR_YOU:
// This is the main source of your plugin.
// It's in this source you'll type all your assembly or c++ code and all 
// the variables and memory zones you need.

// ************  Top/Header section ************
#include "stdafx.h"
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "bass.h"		// prototypes for extra sound library: bass.dll
	// Following header files will be updated for every new version of 
	// the tomb_NextGeneration.dll, so it's better you don't change them
	//  because they will be replaced for any new update.

#include "Tomb_NextGeneration.h" // mnemonic constants defined in tomb_NextGeneration.dll
#include "structures.h" // structure of tomb4 program and trng dll
#include "DefTomb4Funct.h" // defines of tomb4 procedure prototypes
#include "functions.h"  // assigments of real tomb4 address to each tomb4 procedures
#include "macros.h"  // definition of macros

	// FOR_YOU:
	// While the followings are the headers you can use 
	// to type your structures, constants and new tomb4 procedures you 
	// discovered. 
	// Following files are only yours and trng will not ever change them:
#include "macros_mine.h"  // here you define your own macros
#include "constants_mine.h" // here you define your mnemonic constants
#include "structures_mine.h" // here you type your structure definitions
#include "Tomb4Discoveries_mine.h" // here type tomb4 procedures you discovered

#include "trng.h" // list of trng functions imported from trng.cpp source. 

#pragma warning( error : 4706 )
#pragma warning(disable: 4996)

// ************  Early function declarations ************

 
// ************  Global Variables Section *************

// FOR_YOU:
// here you type the variables or memory zones you wish use in different
// C++ procedures.
// If you use the assembly you'll have to type ALL your variables in this
// section.
// for example if you wish have a 32 bits signed variable to store big
// numbers you can type:
// TYPE_HERE:
// int MyNumber;
// and then you can use it in asm in this way:
//		mov  eax, [MyNumber]
// or
//      mov eax, dword ptr [MyNumber]
// same speech for wide memory zones.
// If you wish having a memory zone of 13000 bytes you can type:
//  BYTE MyZone[13000];
// and then you can use it in this way:
//     mov  al, MyNumber[ecx]  ; read the ECXth byte and copy it in AL
// or also:
//     mov al, [MyNumber+ecx] ; same result of above instruction

// Variables and memory zone to TYPE_HERE:

HINSTANCE MyDllInstance=NULL;  // the instance handle of your dll

extern char BufferLog[4096]; // temporary global buffer to host error and warning messages

// FOR_YOU: If you mean create code patch (changes in tomb4 code to call your code in the plugin dll,
// you MUST change the MyTomb4PatcherAddress value (here below) 
// You can discover a free tomb4 zone using TrngPatcher program, with the 
// menu command "Tools->Get Assignment of Free Memory range"
// Note: choose an address, in the given range, terminating with hex 
// digits: 0,4,8, or C
// because it's usefull that the address was a multiple by 4
// If you chose an address used from other plugins you'll get an error and
// the game will be aborted
// note: if you don't mean use code patches you can let 0x0 in following line
DWORD MyTomb4PatcherAddress = 0x0; // <- TYPE_HERE: the new address you chose
								
// this text will contain your plugin name (omitting .dll extension).
// it will be used to give a title to messagebox for error messages or warnings
char TexMyPluginName[80];  
// in this MyData structure you can store all global variables for your plugin
// you have to define them in structures_mine.h source inside structure "StrMyData" or for variable
// to save and restore in savegames, in "StrSavegameGlobalData" or "StrSavegameLocalData" structures
StrMyData MyData;


// ************  Utilities section  ****************



// ************  Patcher Functions section  ***************
// Note: please, don't change or remove the C++ procedure you find here,
// because they are necessary to do work the plugin with the trng dll
// Anyway in many of these functions you can add your code


// FOR_YOU: In this function you insert the callings of functions used to change tomb4 code
// You can get these functions, in the correct format, using Trng Core -> Asm Souce Editor -> Debugging menu
// program
// note: if there is a conflict the function will return "false"
// and the tomb4 program will abort with an error message
bool CreateMyCodePatches(void)
{
	// the call of the code patch to TYPE_HERE:
	// example: 
	// SET_PATCH(Path_RedirCollision)
	// to call the function Patch_RedirCollision() created with TrngPatcher program (command Assmembly->Create Dynamic Patch Generator)

	return true;
}

// ************  Assembly Procedures section  ******************

// FOR_YOU: In the SubPatchArray you'll type all procedure names of your code in the dll you
// wish were called from tomb4 code.
// type them in the order of ax value. So first asm proc in the list, will be called
// with ax=0, while the second in the list will be called with ax=1 ect.



void *SubPatchArray[] = {
	
// TYPE_HERE your asm procedure names to call from tomb4 code
	NULL
};


// ************  MainPatcher() asm procedure  *****************

// FOR_YOU: This is your main patcher procedure.
// All your patch in tomb4 code will call this procedure passing to it, in ax register,
// the number of subpatch to call

BEGIN_ASM_PROC(MainPatcher)
	and eax, 0ffffh
	mov eax, dword ptr [SubPatchArray+eax*4];
	jmp eax
END_ASM_PROC



// ************  CallBack functions section  *****************

// TYPE_HERE: your callback function

void cbInitProgram(int NumberLoadedPlugins, char *VetPluginNames[]) 
{

	// save number of plugins (enclosed yours and the tomb_nextgeneration.dll ) and their names
	// these data will be used to locate IDs of any loaded plugins using FindPluginID() function
	Trng.TotPlugins = NumberLoadedPlugins;
	Trng.pVetPluginNames = VetPluginNames;

	// clear all my global variables
	ClearMemory(&MyData, sizeof(StrMyData));
}


void cbInitGame(void)
{
	// here you can initialize your global data for whole adventure
	// this procedure will be called only once, before loading title level


}

void cbInitLevel(int LevelNow, int LevelOld, DWORD FIL_Flags)
{
	// here you can initialize specific items of currnet level.
	// it will be called only once for level, when all items has been already initialized
	// and just a moment before entering in main game cycle.

}

// called everytime player save the game (but also when lara move from a level to another HUB saving). 
// in this procedure your plugin will save its own data in savegame
// SavingType inform about the kind of saving it is happening (SAVT_... values)
// pAdrZone is a byte pointer where this procedure will save the address from where begin data to save in savegame
// this function will return the size of data to save
// note: It's better you don't change anything of this code. It will save byself of data you stored in MyData.Save
// structure. If you wish adding other variables to save, just you add new fields in Structures of MyData.Save 
DWORD cbSaveMyData(BYTE **pAdrZone, int SavingType)
{
	DWORD SizeData;
	int i;
	static WORD *pVetExtras;
	int TotNWords;
	int TotNewActions;


	if (SavingType & SAVT_COMPLETED) {
		// this call is not to save data but only it is a confirm that the previous saving has been completed
		// now we can free the temporary memory used to save the data in previous call
		if (pVetExtras != NULL) {
			FreeMemory(pVetExtras);
			pVetExtras=NULL;
		}

		return 0;
	}


	TotNWords=0;
	pVetExtras = (WORD *) GetMemory(16);
	// save id of my plugin in first word

	pVetExtras[TotNWords++] = Trng.IdMyPlugin;

	if (SavingType & SAVT_LOCAL_DATA) {
		// save local data

		// save Local structure
		AddNGToken(NGTAG_LOCAL_DATA, NO_ARRAY, sizeof(StrSavegameLocalData), &MyData.Save.Local, 
						&pVetExtras, &TotNWords);


		// save all (currently enabled) progressive actions
		// before saving, compact progressive action array to remove intermediate free records
		TotNewActions=0;

		for (i=0;i<MyData.TotProgrActions;i++) {
			if (MyData.VetProgrActions[i].ActionType != AXN_FREE) {

				MyData.VetProgrActions[TotNewActions] = MyData.VetProgrActions[i];

				TotNewActions++;
			}
		}
		// update new valuese after recompatting
		MyData.LastProgrActionIndex =0;
		MyData.TotProgrActions= TotNewActions;

		// store all progressive action records
		AddNGToken(NGTAG_PROGRESSIVE_ACTIONS, MyData.TotProgrActions, sizeof(StrProgressiveAction), 
				&MyData.VetProgrActions[0], &pVetExtras, &TotNWords);

	}

	if (SavingType & SAVT_GLOBAL_DATA) {
		// save global data
		AddNGToken(NGTAG_GLOBAL_DATA, NO_ARRAY, sizeof(StrSavegameGlobalData), &MyData.Save.Global , 
						&pVetExtras, &TotNWords);
	}
	// write final sequence
	AddTokenFinalSequence(&pVetExtras, &TotNWords);

	// return to trng the infos about start of memory where there are our data and their size:
	*pAdrZone = (BYTE *) pVetExtras;
	SizeData = TotNWords * 2;

	return SizeData;
	

}
// called when a savegame will be loaded (but also when lara move from a level to another)
// pAdrZone will point to memory zone with data just loaded from savegame
// SizeData is the size of data pointed by pAdrZone
// note: it's better you don't change anything of this code. It's alread thought to reload all data you saved in MyData.Save 
// structure. There is no need of changes by you
void cbLoadMyData(BYTE *pAdrZone, DWORD SizeData)
{

	WORD *pVetExtras;
	StrParseNGField  ParseField;
	int Indice;
	int i;
	WORD TotActions;

	
	pVetExtras = (WORD*) pAdrZone;

	Indice=0;

	while (ParseNgField(pVetExtras ,Indice, &ParseField)==true) {
		
		// recover different ng token
		switch (ParseField.Type) {
		case NGTAG_LOCAL_DATA:
			// local data
			memcpy(&MyData.Save.Local, ParseField.pData, sizeof(StrSavegameLocalData));
			break;

		case NGTAG_GLOBAL_DATA:
			// global data
			memcpy(&MyData.Save.Global, ParseField.pData, sizeof(StrSavegameGlobalData));
			break;
			
		case NGTAG_PROGRESSIVE_ACTIONS:
			// progressive actions
			i= ParseField.StartDataIndex;
			// read tot actions value
			TotActions = pVetExtras[i++];
			// copy all tot records
			memcpy(&MyData.VetProgrActions[0], &pVetExtras[i], sizeof(StrProgressiveAction) * TotActions);
			MyData.TotProgrActions = TotActions;
			break;
		}
		Indice= ParseField.NextIndex; 
	}

}
// free memory used to store all data about your customize commands loaded in previous level
void FreeMemoryCustomize(void)
{
	int i;

	for (i=0;i<MyData.BaseCustomizeMine.TotCustomize;i++) {
		FreeMemory(MyData.BaseCustomizeMine.pVetCustomize[i].pVetArg);
	}

	if (MyData.BaseCustomizeMine.TotCustomize > 0) {
		FreeMemory(MyData.BaseCustomizeMine.pVetCustomize);
		MyData.BaseCustomizeMine.TotCustomize=0;
	}


	MyData.BaseCustomizeMine.pVetCustomize=NULL;
}

// free memory used to store all data about your parameters commands loaded in previous level
void FreeMemoryParameters(void)
{
	int i;

	for (i=0;i<MyData.BaseParametersMine.TotParameters;i++) {
		FreeMemory(MyData.BaseParametersMine.pVetParameters[i].pVetArg);
	}

	if (MyData.BaseParametersMine.TotParameters > 0) {
		FreeMemory(MyData.BaseParametersMine.pVetParameters);
		MyData.BaseParametersMine.TotParameters=0;
	}

	MyData.BaseParametersMine.pVetParameters=NULL;
}

// this procedure will be called at end of any level
// you can type here code to free resources allocated for level (that quits now)
void FreeLevelResources(void)
{

	// free memory used to store all data about your customize commands loaded in previous level
	FreeMemoryCustomize();
	// free memory used to store all data about your parameters commands loaded in previous level
	FreeMemoryParameters();
	MyData.BaseAssignSlotMine.TotAssign=0;

}
// it will be called before beginning the loading for a new level.
// you can type here code to initialise all variables used for level (to clear old values changed by previous level)
// and to free resources allocated in old level since now we'are going to another new level.

void cbInitLoadNewLevel(void)
{
	int i;

	StrProgressiveAction *pAction;

	// clear all LOCAL variables
	ClearMemory(&MyData.Save.Local,sizeof(StrSavegameLocalData));

	// clear progressive actions
	pAction= &MyData.VetProgrActions[0];

	for (i=0;i<MyData.TotProgrActions;i++) {
		if (pAction->ActionType != AXN_FREE) {
			// here you could analise to free resoruce allocated from this specific action

			pAction->ActionType = AXN_FREE;
		}
	}

	MyData.TotProgrActions=0;
	MyData.LastProgrActionIndex=0;

	// here you can initialise other variables of MyData different than Local and progressive actions
	// free resources allocate in previous level
	FreeLevelResources();

}



// this procedure will be called everytime a flipeffect of yours will be engaged
// you have to elaborate it and then return a TRET_.. value (most common is TRET_PERFORM_ONCE_AND_GO)
int cbFlipEffectMine(WORD FlipIndex, WORD Timer, WORD Extra, WORD ActivationMode)
{
	int RetValue;
	WORD TimerFull;

	RetValue = enumTRET.PERFORM_ONCE_AND_GO;
	// if the flip has no Extra paremeter you can handle a Timer value with values upto 32767
	// in this case you'll use the following TimerFull variable, where (with following code) we set a unique big number 
	// pasting togheter the timer+extra arguments:
	TimerFull = Timer | (Extra << 8);

	switch (FlipIndex) {
		// here type the "case Number:" for each flipeffect number. At end of the code you'll use the "break;" instruction to signal the code ending
		// Note: when you'll add your first "case Number:" then you can remove the following "case -1: and break;" instructions
	case -1: 
		break;
	default:
		SendToLog("WARNING: Flipeffect trigger number %d has not been handled in cbFlipEffectMine() function", FlipIndex);
		break;
	}

	// if there was the one-shot button enabled, return TRET_PERFORM_NEVER_MORE
	if (ActivationMode & enumSCANF.BUTTON_ONE_SHOT) RetValue= enumTRET.PERFORM_NEVER_MORE; 
	return RetValue;
}
// this procedure will be called everytime an action trigger of yours will be engaged 
// you have to elaborate it and then return a TRET_.. value (most common is TRET_PERFORM_ONCE_AND_GO)
int cbActionMine(WORD ActionIndex, int ItemIndex, WORD Extra, WORD ActivationMode)
{
	int RetValue;
	
	RetValue=TRET_PERFORM_ONCE_AND_GO;

	switch (ActionIndex) {
		// type here the code per your action trigger.
		// add "case Number:" and complete the code with "break;" instruction
	case -1:
		// note: remove this "case -1:" and its "break;" it has been added only to avoid warning messages about empty switch
		break;
	default:
		SendToLog("WARNING: action trigger number %d has not been handled in cbActionMine() function", ActionIndex);
		break;
	}
	
	// if there was the one-shot button enabled, return TRET_PERFORM_NEVER_MORE
	if (ActivationMode & enumSCANF.BUTTON_ONE_SHOT) RetValue= enumTRET.PERFORM_NEVER_MORE;
	return RetValue;


}

// this procedure will be called everytime a conditional trigger of yours will be engaged
// you have to elaborate it and then return a CTRET_.. value (most common is CTRET_ONLY_ONCE_ON_TRUE)
int cbConditionMine(WORD ConditionIndex, int ItemIndex, WORD Extra, WORD ActivationMode)
{
	int RetValue;
	
	RetValue=CTRET_ONLY_ONCE_ON_TRUE;

	switch (ConditionIndex){
		// type here the code for your condition trigger, inserting the code in the section
		// beginning with "case NumberOfAction:" and ending with row "break;"
	case -1:
		// note: remove this "case -1:" and its "break;" it has been added only to avoid warning messages about empty switch
		break;
	default:
		SendToLog("WARNING: condition trigger number %d has not been handled in cbConditionMine() function", ConditionIndex);
		break;


	}
	return RetValue;
	  
}

// this procedure vill be called for each Customize=CUST_... command read from script
// having one of yours CUST_ constant
// CustomizeValue will be the value of your CUST_ constant
// NumberOfItems will be the number of following Item (signed 16 bit values) following
// the CUST_ constant in the customize= script command
// pItemArray is the array with all NumberOfItems arguments of customize command
void cbCustomizeMine(WORD CustomizeValue, int NumberOfItems, short *pItemArray)
{
	// here you can replace this default management of anonymous customize commands
	// with your procedure where you can recognize each different CUST_ value and 
	// save its arguments in meaningful names fields, or elaboriting them immediatly
	// when it is possible (warning: in this moment nothing of level it has been yet loaded, excepting the script section)

	// ----- default management (optional)----
	// all customize values will be saved in MyData structure
	DWORD SizeMem;
	StrGenericCustomize *pMyCust;
	int TotCust;

	// ask memory to have another (new) record of StrGenericCustomize structure
	TotCust= MyData.BaseCustomizeMine.TotCustomize;
	TotCust++;
	SizeMem = TotCust * sizeof(StrGenericCustomize);
	MyData.BaseCustomizeMine.pVetCustomize = 
				(StrGenericCustomize *) ResizeMemory(MyData.BaseCustomizeMine.pVetCustomize, SizeMem);

	pMyCust = & MyData.BaseCustomizeMine.pVetCustomize[TotCust-1];
	
	// now require memory for all arguments (NumberOfItems) store in pItemArray

	pMyCust->pVetArg = (short *) GetMemory(2 * NumberOfItems);
	// copy data
	pMyCust->NArguments = NumberOfItems;
	memcpy(pMyCust->pVetArg, pItemArray, 2*NumberOfItems);
	pMyCust->CustValue = CustomizeValue;

	MyData.BaseCustomizeMine.TotCustomize= TotCust;
	// ---- end of default managemnt for generic customize -------------	
}
// callback called everytime in current level section of the script it has been found an AssignSlot command
// with one of your OBJ_ constants
void cbAssignSlotMine(WORD Slot, WORD ObjType)
{
	int i;

	i = MyData.BaseAssignSlotMine.TotAssign;

	if (i >= MAX_ASSIGN_SLOT_MINE) {
		SendToLog("ERROR: too many AssignSlot= commands for current plugin");
		return;
	}

	MyData.BaseAssignSlotMine.VetAssignSlot[i].MioSlot = Slot;
	MyData.BaseAssignSlotMine.VetAssignSlot[i].TipoSlot = ObjType;
	MyData.BaseAssignSlotMine.TotAssign++;

}
// this procedure vill be called for each Parameters=PARAM_... command read from script
// having one of yours PARAM_ constants
// ParameterValue will be the value of your PARAM_ constant
// NumberOfItems will be the number of following Item (signed 16 bit values) following
// the PARAM_ constant in the customize= script command
// pItemArray is the array with all NumberOfItems arguments of Parameter command
void cbParametersMine(WORD ParameterValue, int NumberOfItems, short *pItemArray)
{
	// here you can replace this default management of anonymous parameters commands
	// with your procedure where you can recognize each different Param_ value and 
	// save its arguments in meaningful names fields, or elaboriting them immediatly
	// when it is possible (warning: in this moment nothing of level it has been yet loaded, excepting the script section)

	// ----- default management (optional)----
	// all parameters values will be saved in MyData structure
	DWORD SizeMem;
	StrGenericParameters *pMyParam;
	int TotParam;

	// ask memory to have another (new) record of StrGenericparameters structure
	TotParam= MyData.BaseParametersMine.TotParameters;
	TotParam++;
	SizeMem = TotParam * sizeof(StrGenericParameters);
	MyData.BaseParametersMine.pVetParameters = 
		(StrGenericParameters *) ResizeMemory(MyData.BaseParametersMine.pVetParameters, SizeMem);

	pMyParam = & MyData.BaseParametersMine.pVetParameters[TotParam-1];
	
	// now require memory for all arguments (NumberOfItems) store in pItemArray

	pMyParam->pVetArg = (short *) GetMemory(2 * NumberOfItems);
	// copy data
	pMyParam->NArguments = NumberOfItems;
	memcpy(pMyParam->pVetArg, pItemArray, 2*NumberOfItems);

	MyData.BaseParametersMine.TotParameters= TotParam;
	// ---- end of default managemnt for generic parameters -------------


}

// this procedure will be called every game cycle (at begin of cycle)
void cbCycleBegin(void)
{

}

// Not yet linked! To link it add to RequireMyCallBacks() function the row:
//  	GET_CALLBACK(CB_CYCLE_END, 0, 0, cbCycleEnd);
// this procedure will be called everygame cycle, at end.
// you have to return a RET_CYCLE_ value
int cbCycleEnd(void)
{


	return RET_CYCLE_CONTINUE;	
}

// this function will be called for each your (common) progressive action to be peformed
void PerformMyProgrAction(StrProgressiveAction *pAction)
{


	switch (pAction->ActionType) {
// replace the "case -1:" with your first "case AXN_...:" progressive action to manage)		
	case -1:
		break;

	}

}
// callback called from trng for each frame in game cycle to perform your (common) progressive action
void cbProgrActionMine(void)
{
	int i;
	StrProgressiveAction *pAction;

	pAction = &MyData.VetProgrActions[0];
	for (i=0;i<MyData.TotProgrActions;i++) {
		if (pAction->ActionType != AXN_FREE) {
			PerformMyProgrAction(pAction);
		}
		pAction++;
	}


}

//Vertical Speed is increased by 6 until it reaches 132
//then it only increases by 1 each frame
int FallSpeed(int SpeedV) {
	if (SpeedV < 130) {
		if (Get(enumGET.MY_CUSTOMIZE_COMMAND, CUST_CLASSIC_ROLLINGBALL_FALL_SPEED, -1) == true) { // check if customize command is used
			Get(enumGET.MY_CUSTOMIZE_COMMAND, CUST_CLASSIC_ROLLINGBALL_FALL_SPEED, -1);
			if (GET.pCust->pVetArg[0] == -1) {
				SpeedV += 6;
			} else {
				SpeedV += GET.pCust->pVetArg[0];
			}
		} else {
			SpeedV += 6;
		}
	} else {
		SpeedV += 1;
	}
	return SpeedV;
}

void GetItemSize(int ItemIndex, int *pBoulderSize, int *pBoulderHeight)
{
          int CordYTop;
          int Distance;

          Get(enumGET.ITEM, ItemIndex,0);
          Get(enumGET.ITEM_COLL_BOX, ItemIndex,0);

          CordYTop = GET.pItem->CordY + GET.pCollItem->MinY;

          Distance = GET.pCollItem->MaxX - GET.pCollItem->MinX;
          Distance = Distance / 2;

          *pBoulderHeight = CordYTop;
          *pBoulderSize = Distance;
}

int GetRelativeAnimation(StrItemTr4 *pItem)
{
          StrSlot *pSaveSlot;
          int FirstAnimation;
          int RelativeIndex;

          // save the slot structure in GET structure to avoid to change this value that it could be used from calling code
          pSaveSlot = GET.pSlot;

          Get(enumGET.SLOT, pItem->SlotID,0);

          FirstAnimation = GET.pSlot->IndexFirstAnim;

          // restore slot structure
          GET.pSlot = pSaveSlot;

          RelativeIndex = pItem->AnimationNow - FirstAnimation;

          return RelativeIndex;
}


void BoulderEnemyCollision(short ItemIndex, int BoulderSize)
{
          StrItemTr4 *pBoulder;
          int i;
          int Index;

          // check if the robot is colliding with some creature
          // save the strucure item of the robot in local variable "pRobot"
          pBoulder = GET.pItem;

          Find(enumFIND.ITEMS_NEARBY, -1, pBoulder->Room, -1, 1024, &pBoulder->CordX);

          for (i=0;i<FIND.TotItems;i++) {
                    Index= FIND.VetItems[i];

                    // ignore if it is the boulder
                    if (Index != ItemIndex) {
                              // there is a moveable item very closed (max one sector of distance) to the robot (and it is not the same robot)
                              // get the structure of this found item
                              Get(enumGET.ITEM, Index,0);
                              // verify that it was a creature and it has been enabled
                              if (TriggerActive(GET.pItem) == true && (GET.pItem->FlagsMain & enumFITEM.CREATURE) != 0) {
                                        // it has been enabled and it is a creature
                                        // now verify if the bounding box is colliding
                                        if (TestBoundCollide(GET.pItem, pBoulder, BoulderSize)==true) {

                                                  // there is a collision: kill the enemy
                                                  // if it is a demigod try to kill with explosion
                                                  // discover if it is a semigod
                                                  Get(enumGET.SLOT, GET.pItem->SlotID,0);
                                                  
                                                  if (GET.pSlot->Flags & enumFSLOT.NO_DAMAGE_FOR_NO_EXPLOSIVE_AMMO) {
                                                            // unkillable (with common measures) try to kill it with an explosion
                                                            PerformActionTrigger(NULL, 14, Index, 2);
                                                            // and then remove it (for those hard to die)
                                                            PerformActionTrigger(NULL, 14, Index, 6);
                                                  }else {
                                                            // it's a common mortal: clear its health
                                                            GET.pItem->Health=0;
                                                  }
                                        }
                              }

                    }
          }

}

void InitialiseTR1Rollingball(short ItemIndex) 
{
	Get(enumGET.ITEM, ItemIndex, 0);
	GET.pItem->StateIdCurrent = 0;
	GET.pItem->StateIdNext = 0;

	Get(enumGET.SLOT, enumSLOT.NEW_SLOT5, 0); // get slot structure of the rollingball
	GET.pItem->AnimationNow = GET.pSlot->IndexFirstAnim; // get first animation
	Get(enumGET.ANIMATION, GET.pItem->AnimationNow, 0);
	GET.pItem->FrameNow = GET.pAnimation->FrameStart;

	GET.pItem->FlagsMain = enumFITEM.NOT_YET_ENABLED;

	GET.pItem->Reserved_38 = 0; // currently rolling? 0 no, 1 yes
}

void CollisionTR1Rollingball(short ItemIndex, StrItemTr4 *pLara, StrCollisionLara *pLaraCollision) 
{
	Get(enumGET.ITEM, ItemIndex, 0);

	// check if lara is close enough
	if (GetMaxDistance(&GET.pItem->CordX, &pLara->CordX, false) > 1024) return;
	if (TestBoundCollide(GET.pItem, pLara, pLaraCollision->LaraSizeX) == false) return;
	if (TestCollision(GET.pItem, pLara) == false) return;

	if (GET.pItem->Reserved_38 == 0) { // Dont't hurt Lara before it was activated or once it stopped
		ItemPushLara(GET.pItem, pLara, pLaraCollision, false, 1);
		return;
	}

	Get(enumGET.LARA, 0, 0);

	ItemPushLara(GET.pItem, pLara, pLaraCollision, true, 1);

	if (pLara->Health > 0 == true) {
		if (GET.pLara->SpeedV != 0) {
			pLara->Health -= 100; // only remove 100HP per frame if Lara is jumping
			DoLotsOfBlood(GET.pLara->CordX, GET.pLara->CordY, GET.pLara->CordZ, 100, 0, GET.pLara->Room, 100); // trigger blood close to her feet if shes jumping
		} else {
			pLara->Health = 0;
			DoLotsOfBlood(GET.pLara->CordX, GET.pLara->CordY - 512, GET.pLara->CordZ, 100, 0, GET.pLara->Room, 100); // trigger blood in the middle of her body
		}

		if (pLara->Health < 1 == true) {
			if (GET.pLara->SpeedV == 0) { // check if Lara is jumping or underwater
				if (Get(enumGET.MY_CUSTOMIZE_COMMAND, CUST_CLASSIC_ROLLINGBALL_DEATH, -1) == true) { // check if custom death is enabled
					Get(enumGET.MY_CUSTOMIZE_COMMAND, CUST_CLASSIC_ROLLINGBALL_DEATH, -1);

					if (16384 > (GET.pLara->OrientationH - GET.pItem->OrientationH) && (GET.pLara->OrientationH - GET.pItem->OrientationH) > -16384) {
						pLara->OrientationH = GET.pItem->OrientationH; // turn Lara in the same direction as the rollingball
						ForceAnimationForLara(139, -1); // force death animation
					} else {
						if (GET.pCust->pVetArg[0] == -1) { // Use default death animation if script command is used but set to IGNORE
							ForceAnimationForLara(139, -1);
						} else {
							GET.pLara->OrientationH = GET.pItem->OrientationH -32768;
							ForceAnimationForLara(GET.pCust->pVetArg[0], -1);
						}
					}
				} else {
					pLara->OrientationH = GET.pItem->OrientationH; // turn Lara in the same direction as the rollingball
					ForceAnimationForLara(139, -1); // force death animation
				}
			}
		}
	}
}

void ControlTR1Rollingball(short ItemIndex)
{
	int BoulderSize;
	int BoulderHeight;

	Get(enumGET.ITEM, ItemIndex, 0);
	GetItemSize(ItemIndex, &BoulderSize, &BoulderHeight);

	if (TriggerActive(GET.pItem) == false) return;

	// Check direction of rollingball
	if (GET.pItem->OrientationH == 0) { // North
		CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ + BoulderSize, GET.pItem->Room);
	} else if (GET.pItem->OrientationH == 16384) { // East
		CheckFloor(GET.pItem->CordX + BoulderSize, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room);
	} else if (GET.pItem->OrientationH == -32768) { // South
		CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ - BoulderSize, GET.pItem->Room);
	} else { // West
		CheckFloor(GET.pItem->CordX - BoulderSize, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room);
	}

	if (FLOOR.TestFullWall == true) { // Check for a wall
		CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room); // In case the ball gets stopped while falling down
		GET.pItem->CordY = FLOOR.FloorHeight;
		GET.pItem->Reserved_38 = 0;
		if (GET.pItem->OcbCode == 1) { // additional stopping animation
			ForceAnimationForItem(GET.pItem, 2, -1);
			GET.pItem->OcbCode = 0;
		} else if (GetRelativeAnimation(GET.pItem) != 2) {
			return;
		}
	}
	if (FLOOR.FloorHeight < GET.pItem->CordY) { // Check if the next floor tile is higher
		CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room);
		GET.pItem->CordY = FLOOR.FloorHeight;
		GET.pItem->Reserved_38 = 0;
		if (GET.pItem->OcbCode == 1) { // additional stopping animation
			ForceAnimationForItem(GET.pItem, 2, -1);
			GET.pItem->OcbCode = 0;
		} else if (GetRelativeAnimation(GET.pItem) != 2) {
			return;
		}
	}
	if (BoulderHeight < FLOOR.CeilingHeight) { // Check if ceiling too low
		CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room);
		GET.pItem->CordY = FLOOR.FloorHeight;
		GET.pItem->Reserved_38 = 0;
		if (GET.pItem->OcbCode == 1) { // additional stopping animation
			ForceAnimationForItem(GET.pItem, 2, -1);
			GET.pItem->OcbCode = 0;
		} else if (GetRelativeAnimation(GET.pItem) != 2) {
			return;
		}
	}

	CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room);
	
	if (GET.pItem->StateIdCurrent == 0 && FLOOR.FloorHeight != GET.pItem->CordY) { // Fall down at the beginning
		GET.pItem->Reserved_38 = 1;
		//GET.pItem->CordY += 64; // constant falling speed
		GET.pItem->SpeedV = FallSpeed(GET.pItem->SpeedV);
		if (GET.pItem->CordY + GET.pItem->SpeedV > FLOOR.FloorHeight) { // prevent it from falling through the floor if it's going too fast
			GET.pItem->CordY = FLOOR.FloorHeight;
		} else {
			GET.pItem->CordY += GET.pItem->SpeedV;
		}
	}
	if (FLOOR.FloorHeight == GET.pItem->CordY) { // Trigger rolling animation when it hits the floor
		GET.pItem->Reserved_38 = 1;
		GET.pItem->StateIdNext = 1;
		GET.pItem->SpeedV = 0;
	}
	if ((FLOOR.FloorHeight - GET.pItem->CordY > 512) && GET.pItem->StateIdCurrent == 1) { // Check if there's a drop while rolling
		GET.pItem->Reserved_34 = 1; // set currently falling variable to 1
	}
	if (FLOOR.WaterHeight - GET.pItem->CordY >= 256) { // prevent bug caused by 1 click deep water pools next to a 1 click high dry ledge
		GET.pItem->Reserved_34 = 1;
	}
	if (GET.pItem->Reserved_34 == 1) { // Drop Ball
		//GET.pItem->CordY += 64; // constant falling speed
		GET.pItem->SpeedV = FallSpeed(GET.pItem->SpeedV);
		GET.pItem->CordY += GET.pItem->SpeedV;
	}
	if ((FLOOR.FloorHeight == GET.pItem->CordY && GET.pItem->Reserved_34 == 1) || FLOOR.FloorHeight < GET.pItem->CordY && GET.pItem->Reserved_34 == 1) { // Stop falling
		GET.pItem->Reserved_34 = 0;
		GET.pItem->SpeedV = 0;
	}
	if (GET.pItem->CordY - FLOOR.WaterHeight < GET.pItem->SpeedV || GET.pItem->CordY - FLOOR.WaterHeight < 64) { // Trigger splash when it hits the water
		Splash(GET.pItem);
	}
	if (GET.pItem->Reserved_34 == 0 && GET.pItem->StateIdCurrent == 1) { // Rollingball is always touching the floor
		GET.pItem->CordY = FLOOR.FloorHeight;
	}
	if (GET.pItem->CordY != FLOOR.FloorHeight) { // stop rolling sound effect when it's falling
		StopSoundEffect(147);
	}
	
	AnimateItem(GET.pItem);
	UpdateItemRoom(ItemIndex);
	BoulderEnemyCollision(ItemIndex, BoulderSize);

	return;
}

void InitTR1Rollingball(void) 
{
	Get(enumGET.SLOT, enumSLOT.NEW_SLOT5, 0);
	if ((GET.pSlot->Flags & enumFSLOT.PRESENT) == 0) {
		// check if there's a rollingball
		return;
	}
	GET.pSlot->pProcInitialise = InitialiseTR1Rollingball;
	GET.pSlot->pProcCollision = CollisionTR1Rollingball;
	GET.pSlot->pProcControl = ControlTR1Rollingball;
	GET.pSlot->Flags = enumFSLOT.AFFECT_LARA_AT_CONTACT | enumFSLOT.CHANGE_POS_ITEM | enumFSLOT.MOVED_BY_ANIMATIONS | enumFSLOT.SFX_LOCAL_SOUND | enumFSLOT.USE_COLLISION_BOX | enumFSLOT.SAVE_ALL_DATA;
}

// inside this function you'll type call to functions to intialise your new objects or customize that olds.
// this callback will be called at start of loading new level and a bit after having started to load level data
void cbInitObjects(void) 
{
	InitTR1Rollingball();
}


// FOR_YOU:
// in this function RequireMyCallBacks() you'll type
// a list of:
//		GET_CALLBACK(CB_..., ,)
// one for each callback you need
bool RequireMyCallBacks(void)
{
// ************  RequireMyCallBacks() function  *****************
	// protype of GET_CALLBACK:
	// GET_CALLBACK(CallBackCB, CBT_Flags, Index, MyProcToCall)
	// default callbacks required always 
	GET_CALLBACK(CB_INIT_PROGRAM, 0, 0, cbInitProgram)
	GET_CALLBACK(CB_INIT_GAME, 0, 0, cbInitGame)
	GET_CALLBACK(CB_INIT_LEVEL, 0,0, cbInitLevel)
	GET_CALLBACK(CB_SAVING_GAME, 0, 0, cbSaveMyData)
	GET_CALLBACK(CB_LOADING_GAME, 0, 0, cbLoadMyData)
	GET_CALLBACK(CB_INIT_LOAD_NEW_LEVEL, 0,0, cbInitLoadNewLevel);
	GET_CALLBACK(CB_FLIPEFFECT_MINE, 0, 0, cbFlipEffectMine);
	GET_CALLBACK(CB_ACTION_MINE, 0,0, cbActionMine);
	GET_CALLBACK(CB_CONDITION_MINE,0,0,cbConditionMine);
	GET_CALLBACK(CB_CUSTOMIZE_MINE, 0,0, cbCustomizeMine);
	GET_CALLBACK(CB_PARAMETER_MINE, 0, 0, cbParametersMine);
	GET_CALLBACK(CB_ASSIGN_SLOT_MINE, 0,0, cbAssignSlotMine);
	GET_CALLBACK(CB_CYCLE_BEGIN, 0, 0, cbCycleBegin);
	GET_CALLBACK(CB_PROGR_ACTION_MINE, 0, 0, cbProgrActionMine);
	GET_CALLBACK(CB_INIT_OBJECTS, 0, 0, cbInitObjects);


	return true;
}
// FOR_YOU:
// This function will be the first code to be executed of your plugin
// It happens when trng will load your plugin.
// In this moment no directX graphic is yet active, so you can show
// message boxes (TryMessageBox) to advise your players or level designer 
// about something
// Note: if you wish abort all (because there is an error or something
// is missing) you have to exit from this function returning: false
bool InitializeAll(void)
{
// ************  InitializeAll() function  ****************
	//  perform all your patches
	CALL_CHECK(CreateMyCodePatches)

	// call the function that requires all callback you need
	CALL_CHECK(RequireMyCallBacks)

	// TYPE_HERE: code to allocate global resource to use in the whole game

	return true;
}

// FOR_YOU: Tyis function will be called when tomb4 game is to be closed.
// you should type in this function further codes to free the global
// resource you had allocated in the InitializeAll() function 
void ReleaseAll(void)
{
// ************  ReleaseAll() function  ******************
	FreeLevelResources();
}


BOOL APIENTRY DllMain( HINSTANCE hInstanceDll, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{

    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			MyDllInstance = hInstanceDll;
			GetTrngInfo();
			// control per check control value about size and alignment with globtomb4 structure
			if (CheckControlGlobTomb4() == false) return FALSE;

			if  (InitializeAll()==false) {
				return FALSE;
			}
			return TRUE;
			

		case DLL_PROCESS_DETACH:
			ReleaseAll();
			break;
    }
    return TRUE;
}


